//
//  script.h
//  Lily
//
//  Created by KMY on 2015/05/08.
//  Copyright (c) 2015年 KMY. All rights reserved.
//

#ifndef __Lily__script__
#define __Lily__script__

#include <stdio.h>
#include "file.h"
#include "character.h"

class Token;
class PreProcessor;
class Generate;
class Block;
class Java;
class JavaSource;

class Script : public File {
public:
	Script();
	Script(const char* fn);
	~Script();
	int getLineNumber();
	void setLineNumber(int num);
	int nextLine();
	bool load(JavaSource* mainClass = 0);
	const char* getScriptIntoChar();
	const lchar* getScriptIntoLchar();
	const lchar* getTokenLchar();
private:
	void init();
	void token();
	void preProcessor();
	void generate(JavaSource* mainClass = 0);
	void compile();
private:
	int linenum;
	char* scriptIntoChar;
	lchar* scriptIntoLchar;
	Token* tokenObj;
	PreProcessor* preProcessorObj;
	Generate* generateObj;
	// Block* fileBlock;
	// static Block* globalBlock;
};

#endif /* defined(__Lily__script__) */
